#property indicator_chart_window

#property indicator_buffers 5

double WidestChannel_high[];
double InsideChannel_high[];
double StandardDeviation[];
double InsideChannel_low[];
double WidestChannel_low[];

extern int STD.Rgres.period=0; /*default 0 means the channel will use the open 
                                 time from "x" bars back on which ever time period 
                                 the indicator is attached to.  one can change to 1,5,
                                 15,30,60...etc to "lock" the start time to a specific 
                                 period, and then view the "locked" channels on a different time period...*/

extern int STD.Rgres.length=56;     // bars back regression begins
extern double STD.Rgres.width=1.618;// widest channel
extern double STD.width=0.618;      // inside channel

int init()   
{ 
   SetIndexBuffer(0,WidestChannel_high);
   SetIndexLabel(0,"WidestChannel_high");
   SetIndexBuffer(1,InsideChannel_high);
   SetIndexLabel(1,"InsideChannel_high");   
   SetIndexBuffer(2,StandardDeviation);
   SetIndexLabel(2,"StandardDeviation");   
   SetIndexBuffer(3,InsideChannel_low);   
   SetIndexLabel(3,"InsideChannel_low");
   SetIndexBuffer(4,WidestChannel_low);   
   SetIndexLabel(4,"WidestChannel_low");   
   return(0);
}
int deinit()   {
   ObjectDelete("regression channel");ObjectDelete("std channel");return(0);
}
int start()   {
   int    counted_bars=IndicatorCounted(),limit, iTF;

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//to refresh properly delete old objects...
   ObjectDelete("regression channel");ObjectDelete("std channel");
//widest channel   
   ObjectCreate("regression channel",OBJ_STDDEVCHANNEL,0,iTime(Symbol(),STD.Rgres.period,STD.Rgres.length),
               Close[STD.Rgres.length],Time[0],Close[0]);
   ObjectSet("regression channel",OBJPROP_DEVIATION,STD.Rgres.width);
   ObjectSet("regression channel",OBJPROP_COLOR,Orange);
   ObjectSet("regression channel",OBJPROP_RAY,true);
   
//inside channel
   ObjectCreate("std channel",OBJ_STDDEVCHANNEL,0,iTime(Symbol(),STD.Rgres.period,STD.Rgres.length),
               Close[STD.Rgres.length],Time[0],Close[0]);
   ObjectSet("std channel",OBJPROP_DEVIATION,STD.width);
   ObjectSet("std channel",OBJPROP_COLOR,Olive);
   ObjectSet("std channel",OBJPROP_RAY,true);   
     
   for(int i=0; i<STD.Rgres.length; i++)
   {   
      double dev = iStdDev(NULL,STD.Rgres.period,STD.Rgres.length,0,MODE_SMA,PRICE_CLOSE,0);
      double innerWidth = STD.width*dev;
      double outerWidth = STD.Rgres.width*dev;     
      double price = ObjectGetValueByShift("std channel",i);    
      WidestChannel_high[i]= price + outerWidth;
      InsideChannel_high[i]= price + innerWidth;
      StandardDeviation[i]= price;
      InsideChannel_low[i]= price - innerWidth;
      WidestChannel_low[i]= price - outerWidth;
   }   
return(0);}